#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys, os
import json

########### lee archivo de configuración ################
dirname = os.path.dirname(__file__)
configfile = os.path.join(dirname, '../config/config.json')

with open(configfile, 'r') as f:
    config = json.load(f)


#print(config['PATHS']['PATH_GEOSENTINEL'])

SENTINEL_PATH = config['PATHS']['PATH_GEOSENTINEL']
###########################################################
sys.path.append(SENTINEL_PATH)

from geosentinel import APISentinel
from geosentinel import polygonToBox
from datetime import date 

#def findSentinelProducts(wkt, startDate, endDate, platform, cloud):
#	sentinel = APISentinel.APISentinel('asalazarg',  'geo135asg')

#	products = sentinel.getProducts(wkt, (startDate, endDate), {"platformname":platform, "cloudcoverpercentage":"[0 TO "+str(cloud)+"]"})

#	return products
#productsCodes = {"L1C":"L1C","L2A":"L1C"}
productType = {"L1C":"S2MSI1C", "L2A":"S2MSI2A"}
def main(argv):

	if len(sys.argv) != 2:
		print("Usage: " + argv[0] + " <JSON File>")
	else:
		jsonFile=open(argv[1]).read()
		cfg = json.loads(jsonFile)

		sentinel = APISentinel.APISentinel(cfg['username'],  cfg['password'])

		wkt = polygonToBox.getWKTPolygonBoundingBox(cfg['wkt'], True)
		productList = sentinel.getProducts(wkt, (cfg['startDate'], cfg['endDate']), {"producttype":productType[cfg["productLevel"]], "platformname":cfg['platform'], "cloudcoverpercentage":"[0 TO "+str(cfg['clouds'])+"]"}, "Contains")
		if len(productList)<=0:
			print ("No products found with 'Contains' trying with 'Intersects'")
			productList = sentinel.getProducts(wkt, (cfg['startDate'], cfg['endDate']), {"producttype":productType[cfg["productLevel"]], "platformname":cfg['platform'], "cloudcoverpercentage":"[0 TO "+str(cfg['clouds'])+"]"})

#			fileNames = [productList[k]['filename'].replace("SAFE", "zip").replace(productsCodes[cfg['productLevel']], cfg['productLevel']) for k in productList.keys() ]
		fileNames = [productList[k]['filename'].replace("SAFE", "zip") for k in productList.keys() ]

		downloadDir =  cfg["productsDir"]+cfg["productLevel"]+"/"
		dirList = os.listdir(downloadDir)

		matchingProducts = set(fileNames).intersection(set(dirList))
		print ( str(len(matchingProducts))+" of " + str(len(fileNames)) +" "+ cfg["productLevel"] + " products found.")
#		rawDir = inDir.replace(cfg['productLevel'],productsCodes[cfg['productLevel']])

 #       print(rawDir)

        text =""
        while text != "yes" and text != "no":
			text = raw_input("Do you want to download this products to "+downloadDir+ " ? (yes, no)")
	if text=="yes":
           sentinel.downloadProducts(productList,downloadDir)


	L2ADir = cfg["productsDir"]+"L2A/"
	if cfg["productLevel"]=="L1C":
		fileNamesL2A = [productList[k]['filename'].replace("SAFE", "zip").replace("L1C", "L2A") for k in productList.keys() ]
		L1CDir = cfg["productsDir"]+"L1C/"
	        linksDir=cfg["projectDir"]+"L1C/"
		if not os.path.exists(linksDir):
			os.mkdir(linksDir)
                L1CDirList = os.listdir(L1CDir)

		#LinkProducts
		fileNames = [productList[k]['filename'].replace("SAFE", "zip") for k in productList.keys() ]
		matchingProducts = set(fileNames).intersection(set(L1CDirList))
		for f in matchingProducts:
			print (f)
                        print("ln -s " + L1CDir+f + " " + linksDir+f)

			os.system("ln -s " + L1CDir+f + " " + linksDir+f)
		print (str(len(matchingProducts)) + " Linked to " + linksDir)

                print ( str(len(matchingProducts))+" of " + str(len(fileNames)) +" L1C products found in L2A.")
        	text =""
	        while text != "yes" and text != "no":
                        text = raw_input("Do you want to convert this products and save them to "+downloadDir+ " ? (yes, no)")
	        if text=="yes":
			#print("L1CProductListToL2A.sh "+rawDir+" "+inDir+" 1")
			os.system("L1CProductListToL2A.sh "+linksDir+" "+L2ADir+" 1") 

        text =""
	linksDir=cfg["projectDir"]+"L2A/"
        while text != "yes" and text != "no":
			text = raw_input("Do you want to link this products to "+linksDir+ " ? (yes, no)")

        if text=="yes":
			fileNames = [productList[k]['filename'].replace("SAFE", "zip").replace("L1C", "L2A") for k in productList.keys() ]
			dirList = os.listdir(L2ADir)

	                matchingProducts = set(fileNames).intersection(set(dirList))

			for f in matchingProducts:
				print (f)
				os.system("ln -s " + L2ADir+f + " " + linksDir+f)
			print (str(len(matchingProducts)) + " Linked to " + linksDir)
		
if __name__ == "__main__":
	main(sys.argv)


#cat results2.txt | xargs -I{} ln -s {} ~/newlinks

